﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	
    public class PlayState extends FlxState
    {
		[Embed(source = '../../data/Tiles.png')] private var ImgTiles:Class;
        [Embed(source = '../../data/tilemap.txt', mimeType = "application/octet-stream")] private var DataMap:Class;
     
		[Embed(source="../../data/bling.mp3")] private var SndBling:Class;
		[Embed(source="../../data/cat.mp3")] private var SndCat:Class;
		[Embed(source = "../../data/open.mp3")] private var SndOpen:Class;
		
        private var _p:Player;
		private var _c:Cat;
		
        private var _map:FlxTilemap;
		private var _k:FlxArray;
		private var _d:FlxArray;
		
		private var _hudkeys:FlxArray;
		private var _itemcount1:FlxText;
		private var _itemcount2:FlxText;
		private var _itemcount3:FlxText;
		private var _itemcount4:FlxText;
		
		private var _endTimer:Number;
		private var _bCanReset:Boolean;
		
		private var _levelLabel:FlxText;
				
        public static var lyrStage:FlxLayer;
        public static var lyrSprites:FlxLayer;
        public static var lyrHUD:FlxLayer;
        
		public static var levelMAX:Number = 20;
		
		public function Shuffle(arr:Array):Array
		{
			var res:Array = arr;
			
			for(var i:int = 0; i < res.length; i++){
				var a = res[i];
				var b = Math.floor(Math.random() * res.length);
				res[i] = res[b];
				res[b] = a;
			}
			return res;
		}
		
		public function Insert(arr,index, value):Array
		{
		   if (!(index >= 0)) return arr;
		   var original:Array = arr.slice()
		   var temp:Array = original.splice(index)
		   original[index] = value
		   original = original.concat(temp)	
		   return original
		}

        public function PlayState():void
        {
            super();
			
			_endTimer = -1;
			_bCanReset = false;
			
			//0 - empty, 1,2,3,4 -> doors; 5,6,7,8 -> keys, 9 -> cat	
			var levels:Array = new Array(
				[//cat
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 9]					
				],
				[//first door
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 5, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 1, 0, 0, 9]					
				],
				[//2 doors
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 1, 0, 6],
					[0, 0, 0, 0, 5, 0, 0, 0],
					[0, 0, 0, 0, 2, 0, 0, 9]					
				],
				[//multiple routes
					[0, 0, 0, 0, 1, 0, 6, 0],
					[0, 5, 0, 0, 0, 0, 0, 0],
					[0, 0, 2, 0, 5, 0, 0, 0],
					[0, 0, 0, 1, 0, 0, 0, 9]					
				],
				[//first dead end
					[0, 0, 0, 1, 0, 0, 0, 0],
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 5, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 1, 0, 0, 0, 9]					
				],
				[
					[0, 0, 0, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 1, 5, 6, 0],
					[0, 0, 5, 0, 0, 0, 0, 0],
					[0, 0, 0, 0, 1, 0, 2, 9]					
				],
				[
					[0, 0, 1, 6, 0, 0, 0, 0],
					[0, 0, 1, 7, 0, 3, 5, 5],
					[0, 0, 5, 0, 5, 2, 5, 5],
					[0, 0, 1, 0, 1, 1, 1, 9]					
				],
				[
					[0, 0, 1, 6, 0, 0, 0, 0],
					[0, 1, 7, 1, 3, 5, 5, 5],
					[0, 0, 5, 0, 5, 2, 5, 5],
					[0, 0, 1, 0, 1, 1, 1, 9]					
				],
				[
					[1, 7, 3, 3, 1, 6, 0, 0],
					[1, 7, 5,3, 3, 5, 5, 5, 0],
					[1, 7, 3, 3, 3, 6, 0, 0],
					[0, 0, 5, 5, 5, 1, 2, 9]					
				],
				[
					[5, 2, 9, 0, 0, 0, 0, 0],
					[1, 6, 2, 8, 0, 0, 0, 0],
					[1, 7, 3, 0, 0, 0, 0, 0],
					[3, 0, 0, 6, 0, 0, 0, 0]					
				],
				[
					[3, 5, 3, 5, 3, 5, 5, 0],
					[2, 7, 2, 7, 2, 7, 0, 0],
					[1, 6, 1, 6, 1, 6, 0, 0],
					[5, 0, 0, 0, 0, 1, 1, 9]					
				],
				[
					[5, 2, 6, 6, 0, 0, 0, 0],
					[1, 5, 5, 0, 0, 0, 0, 0],
					[3, 7, 6, 0, 0, 0, 0, 0],
					[1, 7, 3, 2, 2,9, 0, 0, 0]					
				],
				[
					[5, 1, 6, 2, 3, 9, 0, 0],
					[2, 5, 7, 0, 0, 0, 0, 0],
					[3, 1, 7, 6, 0, 0, 0, 0],
					[1, 3, 6, 5, 0, 0, 0, 0]					
				],
				[
					[5,7, 0, 0, 0, 0, 0, 0],
					[2, 3, 9, 0, 0, 0, 0, 0],
					[1, 6, 1, 5, 0, 0, 0, 0],
					[1, 5, 1, 6, 0, 0, 0, 0]					
				],
				[
					[5, 1, 6, 2, 3, 8, 0, 0],
					[1, 7, 3, 4, 9, 0, 0, 0],
					[2, 5, 7, 8, 0, 0, 0, 0],
					[3, 2, 8, 0, 0, 0, 0, 0]					
				],
				[
					[5, 6, 7, 1, 2, 3, 4, 9],
					[1, 7, 8, 0, 0, 0, 0, 0],
					[2, 7, 7, 0, 0, 0, 0, 0],
					[3, 8, 6, 0, 0, 0, 0, 0]					
				],
				[
					[5, 1, 7, 8, 4, 7, 0, 0],
					[1, 7, 6, 3, 5, 0, 0, 0],
					[1, 8, 6, 4, 6, 5, 5, 5],
					[1, 7, 5, 1, 3, 3, 4, 9]					
				],
				[
					[5, 2, 3, 9, 0, 0, 0, 0],
					[1, 6, 1, 6, 5, 0, 0, 0],
					[1, 6, 3, 6, 5, 0, 0, 0],
					[1, 7, 5, 0, 0, 0, 0, 0]					
				],
				[
					[5, 1, 7, 2, 2, 8, 0, 0],
					[6, 1, 5, 2, 6, 1, 6, 5],
					[7, 1, 5, 1, 1, 7, 1, 8],
					[4, 9, 0, 0, 0, 0, 0, 0]					
				],
				[
					[5, 1, 8, 2, 1, 9, 0, 0],
					[3, 3, 6, 0, 0, 0, 0, 0],
					[1, 7, 7, 3, 6, 5, 0, 0],
					[4, 5, 8, 0, 0, 0, 0, 0]					
				]
				);  
			
			var level:Array = levels[FlxG.level];
			
			//1: shuffle rows
			level = Shuffle(level);
			
			//2: permute colors
			var colors:Array = [0, 1, 2,3];
			colors = Shuffle(colors);
			trace(colors);
			trace(level);
			//3: apply color permutation
			for (var i:int = 0; i < level.length; i++)
			{
				var row:Array = level[i];
				for (var j:int = 0; j < row.length; j++)
				{
					switch (row[j])
					{
						case 1:
						case 2:
						case 3:
						case 4:
							row[j] = colors[(row[j] - 1)]+1;
						break;
						case 5:
						case 6:
						case 7:
						case 8:
							row[j] = colors[(row[j] - 5)]+5;
						break;
					}
				}
			}
			trace(level);
			
            lyrStage = new FlxLayer;
			lyrSprites = new FlxLayer;
            lyrHUD = new FlxLayer;
            
            _p = new Player(148, 148);
			
			_c = new Cat(144, 20,_p);
			
			_k = new FlxArray;			
			_d = new FlxArray;
			
			
			// 4:strip zeros
			for (var k:int = 0; k < 4; k++)
			{
				for (var l:int = 7 ; l >=0; l--)
				{
					if (level[k][l] == 0)
						level[k].splice(l, 1);
				}
			}
			
			//5:reinsert zeros

			for (var m:int = 0; m < 4; m++)
			{
				if (level[m].length < 8)
				{
					for (; level[m].length < 8;)
					{						
						level[m] = Insert(level[m], Math.round(Math.random() * level[m].length), 0);
					}
				}
			}
						
			
			//6: populate the level
			for (j = 0; j < 8; j++)
			{
				var px:int;
				var py:int;
				px = 144 - 16 - j * 16;
				py = 144;
				switch(level[0][j])
				{
					case 0:
					break;
					case 1:
					_d.add(lyrSprites.add(new Door(px, py, _p,0)));					
					break;
					case 2:
					_d.add(lyrSprites.add(new Door(px, py, _p,1)));
					break;
					case 3:
					_d.add(lyrSprites.add(new Door(px, py, _p,2)));
					break;
					case 4:
					_d.add(lyrSprites.add(new Door(px, py, _p,3)));
					break;
					case 5:
					_k.add(lyrSprites.add(new Key(px,py, _p,0)));
					break;
					case 6:
					_k.add(lyrSprites.add(new Key(px,py, _p,1)));
					break;
					case 7:
					_k.add(lyrSprites.add(new Key(px,py, _p,2)));
					break;
					case 8:
					_k.add(lyrSprites.add(new Key(px,py, _p,3)));
					break;
					case 9:
					_c.x = px;
					_c.y = py;
					break;
				}
				px = 144 + 16 + j * 16;
				py = 144;
				switch(level[1][j])
				{
					case 0:
					break;
					case 1:
					_d.add(lyrSprites.add(new Door(px, py, _p,0)));					
					break;
					case 2:
					_d.add(lyrSprites.add(new Door(px, py, _p,1)));
					break;
					case 3:
					_d.add(lyrSprites.add(new Door(px, py, _p,2)));
					break;
					case 4:
					_d.add(lyrSprites.add(new Door(px, py, _p,3)));
					break;
					case 5:
					_k.add(lyrSprites.add(new Key(px,py, _p,0)));
					break;
					case 6:
					_k.add(lyrSprites.add(new Key(px,py, _p,1)));
					break;
					case 7:
					_k.add(lyrSprites.add(new Key(px,py, _p,2)));
					break;
					case 8:
					_k.add(lyrSprites.add(new Key(px,py, _p,3)));
					break;
					case 9:
					_c.x = px;
					_c.y = py;
					break;
				}
				py = 144 - 16 - j * 16;
				px = 144;
				switch(level[2][j])
				{
					case 0:
					break;
					case 1:
					_d.add(lyrSprites.add(new Door(px, py, _p,0)));					
					break;
					case 2:
					_d.add(lyrSprites.add(new Door(px, py, _p,1)));
					break;
					case 3:
					_d.add(lyrSprites.add(new Door(px, py, _p,2)));
					break;
					case 4:
					_d.add(lyrSprites.add(new Door(px, py, _p,3)));
					break;
					case 5:
					_k.add(lyrSprites.add(new Key(px,py, _p,0)));
					break;
					case 6:
					_k.add(lyrSprites.add(new Key(px,py, _p,1)));
					break;
					case 7:
					_k.add(lyrSprites.add(new Key(px,py, _p,2)));
					break;
					case 8:
					_k.add(lyrSprites.add(new Key(px,py, _p,3)));
					break;
					case 9:
					_c.x = px;
					_c.y = py;
					break;
				}
				py = 144 + 16 + j * 16;
				px = 144;
				switch(level[3][j])
				{
					case 0:
					break;
					case 1:
					_d.add(lyrSprites.add(new Door(px, py, _p,0)));					
					break;
					case 2:
					_d.add(lyrSprites.add(new Door(px, py, _p,1)));
					break;
					case 3:
					_d.add(lyrSprites.add(new Door(px, py, _p,2)));
					break;
					case 4:
					_d.add(lyrSprites.add(new Door(px, py, _p,3)));
					break;
					case 5:
					_k.add(lyrSprites.add(new Key(px,py, _p,0)));
					break;
					case 6:
					_k.add(lyrSprites.add(new Key(px,py, _p,1)));
					break;
					case 7:
					_k.add(lyrSprites.add(new Key(px,py, _p,2)));
					break;
					case 8:
					_k.add(lyrSprites.add(new Key(px,py, _p,3)));
					break;
					case 9:
					_c.x = px;
					_c.y = py;
					break;
				}
			}
			
            //FlxG.follow(_p,2.5);
            //FlxG.followAdjust(0.5, 0.5);
            //FlxG.followBounds(1,1,640-1,480-1);
            
			_hudkeys = new FlxArray;
			_hudkeys.add(lyrHUD.add(new Key(FlxG.width -20, 7, _p,0)));
			_hudkeys.add(lyrHUD.add(new Key(FlxG.width -20, 25, _p,1)));
			_hudkeys.add(lyrHUD.add(new Key(FlxG.width -20, 43, _p,2)));
			_hudkeys.add(lyrHUD.add(new Key(FlxG.width -20, 61, _p,3)));
			
			_itemcount1 = new FlxText(FlxG.width - 48-18, 2, 48, 16, _p.ic1.toString(), 0xffffffff, null, 16, "right");
            _itemcount1.scrollFactor.x = _itemcount1.scrollFactor.y = 0;            
			lyrHUD.add(_itemcount1);
			_itemcount2 = new FlxText(FlxG.width - 48-18, 20, 48, 16, _p.ic1.toString(), 0xffffffff, null, 16, "right");
            _itemcount2.scrollFactor.x = _itemcount2.scrollFactor.y = 0;            
			lyrHUD.add(_itemcount2);
			_itemcount3 = new FlxText(FlxG.width - 48-18, 38, 48, 16, _p.ic1.toString(), 0xffffffff, null, 16, "right");
            _itemcount3.scrollFactor.x = _itemcount3.scrollFactor.y = 0;            
			lyrHUD.add(_itemcount3);
			_itemcount4 = new FlxText(FlxG.width - 48-18, 56, 48, 16, _p.ic1.toString(), 0xffffffff, null, 16, "right");
            _itemcount4.scrollFactor.x = _itemcount4.scrollFactor.y = 0;            
			lyrHUD.add(_itemcount4);
			
			_levelLabel = new FlxText(5, 5, 100, 16, "Level " + (FlxG.level+1), 0xffffffff, null, 16, "left");
			_levelLabel.scrollFactor.x = _levelLabel.scrollFactor.y = 0;            
			lyrHUD.add(_levelLabel);
			
            _map = new FlxTilemap(new DataMap, ImgTiles, 1);
            lyrStage.add(_map);        
			
			lyrSprites.add(_c);
            lyrSprites.add(_p);

            this.add(lyrStage);
            this.add(lyrSprites);
            this.add(lyrHUD);
        }
        
        override public function update():void
        {			
			if (_endTimer > 0)
			{						
				_endTimer -= FlxG.elapsed;	
				if (_endTimer <= 0)
				{
					FlxG.level++;
					FlxG.switchState(IntroState);
				}
				
				return;
			}
			
            super.update();
            _map.collide(_p);
		    FlxG.overlapArray(_k, _p, KeyHit);
		    FlxG.overlapArray(_d, _p, DoorHit);
			   
			if (_p.overlaps(_c))
			{
				_endTimer = 2.3;	
				FlxG.play(SndCat);
				_p.play("happy", true);
				_c.play("happy", true);
			}
			
			if((FlxG.justPressed(FlxG.A) || FlxG.justPressed(FlxG.B)) && (_bCanReset))
				FlxG.switchState(IntroState);
		}		
		
		private function KeyHit(K:Key, P:Player):void
        {
			_bCanReset = true;
			
			K.kill();
			FlxG.play(SndBling);
			
			switch(K.color)
			{
				case 0:
				P.ic1++;
				_itemcount1.setText(P.ic1.toString());
				break;
				case 1:
				P.ic2++;
				_itemcount2.setText(P.ic2.toString());
				break;
				case 2:
				P.ic3++;
				_itemcount3.setText(P.ic3.toString());
				break;
				case 3:
				P.ic4++;
				_itemcount4.setText(P.ic4.toString());
				break;
			}
        }
		
		private function DoorHit(D:Door, P:Player):void
        {			
			D.collide(P);	
			var bRemove:Boolean = false;
			switch (D.color)
			{
				case 0:
				if (P.ic1 > 0)
				{
					P.ic1--;
					_itemcount1.setText(P.ic1.toString());
					bRemove = true;
				}
				break;
				case 1:
				if (P.ic2 > 0)
				{
					P.ic2--;
					_itemcount2.setText(P.ic2.toString());					
					bRemove = true;
				}
				break;
				case 2:
				if (P.ic3 > 0)
				{
					P.ic3--;
					_itemcount3.setText(P.ic3.toString());					
					bRemove = true;
				}
				break;
				case 3:
				if (P.ic4 > 0)
				{
					P.ic4--;
					_itemcount4.setText(P.ic4.toString());					
					bRemove = true;
				}
				break;
			}
			if (bRemove)
			{
				D.kill();				
				FlxG.play(SndOpen);
			}		
        }
    }    
}