﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Player extends FlxSprite
    {
        [Embed(source='../../data/Player.png')] private var ImgPlayer:Class;
        
        private var _move_speed:int = 1000;
        private var _jump_power:int = 800;   
        private var _max_health:int = 10;
        private var _hurt_counter:Number = 0;
		
		public var ic1:uint = 0;
		public var ic2:uint = 0;
		public var ic3:uint = 0;
		public var ic4:uint = 0;

		private var inventorychanged:Boolean = false;
		
        public function Player(X:Number,Y:Number):void
        {
            super(ImgPlayer, X, Y, true, true);//Max speeds
            maxVelocity.x = 200;
            maxVelocity.y = 200;
            //Set the player health
            health = 10;
            //Gravity
            acceleration.y = 0;            
            //Friction
            drag.x = 500;
            drag.y = 500;
            //bounding box tweaks
            width = 8;
            height = 8
            offset.x = 4;
            offset.y = 4;
			addAnimation("normal", [0]);
            addAnimation("happy", [1]);
			play("normal");		
        }
    
        override public function update():void
        {

            if(dead)
            {
                if(finished) exists = false;
                else
                    super.update();
                return;
            }
            if (_hurt_counter > 0)
            {
                _hurt_counter -= FlxG.elapsed*3;
            }

            if(FlxG.kLeft)
            {
                velocity.x -= _move_speed * FlxG.elapsed;
            }
            if (FlxG.kRight)
            {
                velocity.x += _move_speed * FlxG.elapsed;                
            }
			if (FlxG.kUp)
			{
				velocity.y -= _move_speed * FlxG.elapsed;
			}
			if (FlxG.kDown)
			{
				velocity.y += _move_speed * FlxG.elapsed;
			}
            super.update();
        }

        override public function hurt(Damage:Number):void
        {
            _hurt_counter = 1;
            return super.hurt(Damage);
        }       
    }
}